<?php

namespace QUI\QueueManager\Interfaces;

use QUI\QueueManager\QueueJob;
use QUI\QueueManager\QueueJobUUID;

interface QueueJobRepositoryInterface
{
    /**
     * @param QueueJob $job
     * @return QueueJob - Inserted QueueJob with UUID
     */
    public function insert(QueueJob $job): QueueJob;

    /**
     * @param QueueJob $job
     * @return void
     */
    public function update(QueueJob $job): void;

    /**
     * @param QueueJobUUID $jobId
     * @return QueueJob|null
     */
    public function find(QueueJobUUID $jobId): ?QueueJob;

    /**
     * @param array $where (optional) - WHERE clause (QUIQQER DB syntax)
     * @return QueueJob[]
     */
    public function findAll(array $where = []): array;
}
