<?php

namespace QUI\QueueManager;

use InvalidArgumentException;
use QUI\QueueManager\Interfaces\QuiqqerQueueWorkerInterface;

use function is_a;

/**
 * Queue job specifically intended for a QUIQQER task worker.
 */
class QuiqqerWorkerQueueJob extends QueueJob
{
    public function __construct(
        string $workerClass,
        ?QueueJobUUID $uuid = null,
        ?QueueJobAttributes $jobAttributes = null
    ) {
        if (!is_a($workerClass, QuiqqerQueueWorkerInterface::class, true)) {
            throw new InvalidArgumentException(
                "Class '$workerClass' does not implement " . QuiqqerQueueWorkerInterface::class
            );
        }

        parent::__construct($uuid, $jobAttributes);
        $this->data->set('workerClass', $workerClass);
    }
}
